#include <opencv2/imgcodecs.hpp>
#include <opencv2/imgproc.hpp>
#include <opencv2/videoio.hpp>
#include <opencv2/highgui.hpp>
#include <opencv2/video.hpp>
#include "ImageOperators.h"

using namespace cv;

int main(int argc, char* argv[])
{	
	VideoCapture capture;
	if(argc < 2)		
	{
		capture.open(1); 
	}
	else
	{
		capture.open(argv[1]);
		capture.set(CAP_PROP_FRAME_WIDTH, 640);
		capture.set(CAP_PROP_FRAME_HEIGHT, 480);
	}

	namedWindow("PreviewWindow");	
	
	Mat frame;
	while(capture.read(frame))
	{
		Mat resized;
		resize(frame, resized, Size(640,480));

		imshow("PreviewWindow-frame", resized);

		Mat gray;
		cvtColor(resized, gray, CV_BGR2GRAY);
		Mat mask;
		edgeDetect(gray, mask);
		imshow("PreviewWindow", mask);

		char key = static_cast<char>(waitKey(1));
		if (key == 27) { printf("exit"); break; }
	}
}